"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var builder_block_decorator_1 = require("../decorators/builder-block.decorator");
var react_native_render_html_1 = require("react-native-render-html");
var Embed = /** @class */ (function (_super) {
    __extends(Embed, _super);
    function Embed() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Embed.prototype.render = function () {
        return react_1.default.createElement(react_native_render_html_1.default, { html: this.props.content || ' ' });
    };
    Embed = __decorate([
        builder_block_decorator_1.BuilderBlock({
            name: 'Embed',
            inputs: [
                {
                    name: 'url',
                    type: 'url',
                    required: true,
                    defaultValue: '',
                    helperText: 'e.g. enter a youtube url, google map, etc',
                    onChange: function (options) {
                        var url = options.get('url');
                        if (url) {
                            options.set('content', 'Loading...');
                            // TODO: get this out of here!
                            var apiKey = 'ae0e60e78201a3f2b0de4b';
                            return fetch("https://iframe.ly/api/iframely?url=" + url + "&api_key=" + apiKey)
                                .then(function (res) { return res.json(); })
                                .then(function (data) {
                                if (options.get('url') === url) {
                                    if (data.html) {
                                        options.set('content', data.html);
                                    }
                                    else {
                                        options.set('content', 'Invalid url, please try another');
                                    }
                                }
                            })
                                .catch(function (err) {
                                options.set('content', 'There was an error embedding this URL, please try again or another URL');
                            });
                        }
                        else {
                            options.delete('content');
                        }
                    },
                },
                {
                    name: 'content',
                    type: 'html',
                    defaultValue: "<div style=\"padding: 20px; text-align: center\">(Choose an embed URL)<div>",
                    hideFromUI: true,
                },
            ],
        })
    ], Embed);
    return Embed;
}(react_1.default.Component));
exports.Embed = Embed;
//# sourceMappingURL=Embed.js.map