"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var builder_block_decorator_1 = require("../../decorators/builder-block.decorator");
var sdk_1 = require("@builder.io/sdk");
var react_native_1 = require("react-native");
var FormInput = /** @class */ (function (_super) {
    __extends(FormInput, _super);
    function FormInput() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FormInput.prototype.render = function () {
        return (react_1.default.createElement(react_native_1.TextInput, __assign({ key: sdk_1.Builder.isEditing && this.props.defaultValue ? this.props.defaultValue : 'default-key', placeholder: this.props.placeholder, type: this.props.type, name: this.props.name, value: this.props.value, defaultValue: this.props.defaultValue }, this.props.attributes)));
    };
    FormInput = __decorate([
        builder_block_decorator_1.BuilderBlock({
            name: 'Form:Input',
            image: 'https://cdn.builder.io/api/v1/image/assets%2FIsxPKMo2gPRRKeakUztj1D6uqed2%2Fad6f37889d9e40bbbbc72cdb5875d6ca',
            inputs: [
                {
                    name: 'type',
                    type: 'text',
                    enum: [
                        'text',
                        'number',
                        'email',
                        'url',
                        'checkbox',
                        'radio',
                        'range',
                        'date',
                        'datetime-local',
                        'search',
                        'tel',
                        'time',
                        'month',
                        'week',
                        'color',
                        'hidden',
                    ],
                    defaultValue: 'text',
                },
                // TODO: handle value vs default value automatically like ng-model
                {
                    name: 'defaultValue',
                    type: 'string',
                },
                {
                    name: 'value',
                    type: 'string',
                    advanced: true,
                },
                {
                    name: 'placeholder',
                    type: 'string',
                    defaultValue: 'Hello there',
                },
                {
                    name: 'name',
                    type: 'string',
                },
                {
                    name: 'required',
                    type: 'boolean',
                    defaultValue: false,
                },
            ],
            // TODO
            // TODO: call editorHooks?
            // ...({
            //   hooks: {
            //     'ElementLayout:shiftBottomSide': (element: Element, amount: number, snap: boolean) => {
            //       // TODO: either update line height or split the padding padding on bottom sides hmm
            //     }
            //   } as any,
            // }),
            noWrap: true,
            defaultStyles: {
                paddingTop: '10px',
                paddingBottom: '10px',
                paddingLeft: '10px',
                paddingRight: '10px',
                borderRadius: '3px',
                borderWidth: '1px',
                borderStyle: 'solid',
                borderColor: '#ccc',
            },
        })
    ], FormInput);
    return FormInput;
}(react_1.default.Component));
exports.FormInput = FormInput;
//# sourceMappingURL=Input.js.map