import React from 'react';
import { Subscription, GetContentOptions } from '@builder.io/sdk';
import { GestureResponderEvent } from 'react-native';
export interface BuilderContentProps<ContentType> {
    contentLoaded?: (content: any) => void;
    contentError?: (error: any) => void;
    modelName: string;
    options?: GetContentOptions;
    children: (content: ContentType, loading?: boolean, fullData?: any) => React.ReactNode;
    inline?: boolean;
}
export declare class BuilderContent<ContentType extends object = any> extends React.Component<BuilderContentProps<ContentType>> {
    state: {
        loading: boolean;
        data: any;
    };
    subscriptions: Subscription<Function>;
    firstLoad: boolean;
    clicked: boolean;
    trackedImpression: boolean;
    componentDidMount(): void;
    subscribeToContent(): void;
    componentWillUnmount(): void;
    onClick: (reactEvent: GestureResponderEvent) => void;
    render(): JSX.Element;
}
